
#ifndef _MAIL_DLG_H_
#define _MAIL_DLG_H_

#include <qgrpbox.h>
#include <qchkbox.h>
#include <qdialog.h>
#include <qlined.h>
#include <qpushbt.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qframe.h>
#include <qmlined.h>

#if defined(Status)
#undef Status
#endif

#include "kurllabel.h"

#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include "kxicq.h"



//#include "kedit.h"

class Mail : public QDialog
{
      Q_OBJECT

   public:

      Mail (unsigned long int uin, mainWin *parent = 0, const char *name=0);

      QMultiLineEdit* dlgedit_MultiLineEdit_1;

      unsigned long int to;
/*    QLineEdit 	*recipient;

	 QLineEdit 	*subject;
	 QLabel 	*subjectlabel;*/
      //   QString getRecipient(){return recipient->text();};
      //   QString getSubject(){return subject->text();};
      //    char *getText() { return dlgedit_MultiLineEdit_1->text().data(); };

   protected:

      void focusInEvent( QFocusEvent *);
      void resizeEvent ( QResizeEvent *);

   private:
/*
	 QPushButton *ok, *cancel;
	 QGroupBox 	*frame1;

*/

      public slots:

      void cancel_slot();
      void ok_slot();

};

///////////////////////////////////////////////////////////////////////////

class sendUrl : public QDialog
{
      Q_OBJECT

   public:

      sendUrl (unsigned long int uin, mainWin *parent = 0, const char *name=0);

      QMultiLineEdit* dlgedit_MultiLineEdit_1;
      QMultiLineEdit* dlgedit_MultiLineEdit_2;
      unsigned long int to;
/*    QLineEdit 	*recipient;

	 QLineEdit 	*subject;
	 QLabel 	*subjectlabel;*/
      //   QString getRecipient(){return recipient->text();};
      //   QString getSubject(){return subject->text();};
      //    char *getText() { return dlgedit_MultiLineEdit_1->text().data(); };

   protected:

      void focusInEvent( QFocusEvent *);
      void resizeEvent ( QResizeEvent *);

   private:
/*
	 QPushButton *ok, *cancel;
	 QGroupBox 	*frame1;

*/

      public slots:

      void cancel_slot();
      void ok_slot();

};

/////////////////

class readMail : public QDialog
{
      Q_OBJECT

   public:

      readMail (mainWin *parent = 0, const char *name=0);

      QMultiLineEdit* dlgedit_MultiLineEdit_2;
      QMultiLineEdit* dlgedit_MultiLineEdit_3;
      QMultiLineEdit* dlgedit_MultiLineEdit_4;
      QMultiLineEdit* dlgedit_MultiLineEdit_5;
      QMultiLineEdit* dlgedit_MultiLineEdit_6;

      unsigned long int to;

      void setUin(unsigned long int uin) ;
      void setDate(int m, int d, int y);
      void setTime(int h, int m);
      void setMessage(char *msg);

   protected:

      void focusInEvent( QFocusEvent *);
      void resizeEvent ( QResizeEvent *);

   private:
/*
	 QPushButton *ok, *cancel;
	 QGroupBox 	*frame1;

*/

      public slots:
	 void prev_slot();
      void next_slot();
      void cancel_slot();
      void ok_slot();
      void reply_slot();

};


///////////////////

class readUrl : public QDialog
{
      Q_OBJECT

   public:

      readUrl (mainWin *parent = 0, const char *name=0);



      QMultiLineEdit* dlgedit_MultiLineEdit_2;
      QMultiLineEdit* dlgedit_MultiLineEdit_3;
      QMultiLineEdit* dlgedit_MultiLineEdit_4;
      QMultiLineEdit* dlgedit_MultiLineEdit_5;
      QMultiLineEdit* dlgedit_MultiLineEdit_6;
      QMultiLineEdit* dlgedit_MultiLineEdit_7;

      unsigned long int to;

      void setUin(unsigned long int uin) ;
      void setDate(int m, int d, int y);
      void setTime(int h, int m);
      void setMessage(char *msg);
      void setUrl(char *url);

   protected:

      void focusInEvent( QFocusEvent *);
      void resizeEvent ( QResizeEvent *);

   private:
/*
	 QPushButton *ok, *cancel;
	 QGroupBox 	*frame1;

*/

      public slots:
	 //      void prev_slot();
      //      void next_slot();
      void cancel_slot();
      void ok_slot();
      void reply_slot();

};

//////////////////////////////////////////////

class Read : public QDialog
{
      Q_OBJECT
   public:
      Read(UIN u,mainWin *parent=0, const char *name=0);
      ~Read();

   private:

      UIN uin;
      MSG *pntMsg;
      int found,wait,view;

      QFrame *msgView,*urlView,*addView,*buttonView;
      
      QPushButton *okButton, *cancelButton, *replyButton,*whoisButton;
      QPushButton *nextButton, *prevButton;
      
      QButtonGroup *msgGroup, *urlGroup, *addGroup;
      
      QMultiLineEdit *msgViewMsg, *urlViewMsg;
      KURLLabel *urlViewUrl;
      QLabel *msgViewUin, *msgViewNick, *msgViewTime, *msgViewDate;
      QLabel *urlViewUin, *urlViewNick, *urlViewTime, *urlViewDate;
      QLabel *addViewUin, *addViewNick, *addViewTime, *addViewDate;
      QLabel *addViewFirst, *addViewLast, *addViewEmail, *addViewrNick;
      
      
      
      
      QCheckBox *msgViewRead, *urlViewRead, *addViewRead;
      

      void showMsg();
      void lastMsg();
      void firstMsg();
      void nextMsg();
      void prevMsg();
   
   protected:


   private slots:
      void processURL(const char *);
      void ok_slot();
      void cancel_slot();
      void reply_slot();
      void whois_slot();
      void next_slot();
      void prev_slot();


};

#endif
