
#ifndef K_H
#define K_H

#define KXICQ_version "0.2.2"

#define ID_VIEW_MONTH 30
#define ID_VIEW_WEEK 31
#define ID_VIEW_DAY 32

#define ID_MENU_CONNECT 0
#define ID_MENU_DISCONNECT 1
#define ID_MENU_STATUS 2
#define ID_MENU_INFO 3
#define ID_MENU_CONFIG 4
#define ID_MENU_QUIT 5

#define TYPE_SERVER 0

#include <qlistbox.h>
#include "users.h"
#include <ktoolbar.h>
#include <ktopwidget.h>
#include <kstatusbar.h>
#include <kconfig.h>
#include <qframe.h>
#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include <libXicq.h>

struct kxicqConfig
{
   char *browser;
   char typeBrowser;
   char autoConnect;
   char sound;
   char alwaysSound;
};


void loadKxicqConfig();
void unix2dos(char *txt);
void loggedon();
void searchResult(SEARCH_RESULT *result);
void loggedIn();
void updateContact(unsigned long int uin);
void message(MESSAGE *message);
void url(URL *url);
void added(ADDED *added);
void disconnected();
int askRead(UIN uin);
int ifMsg(UIN);
void saveMsgs();
void writeNewConfigFile(USER_CONFIGURATION &user_cfg);
void userConfigure(USER_CONFIGURATION *user_cfg);

class mainWin : public KTopLevelWidget
{
      Q_OBJECT
   public:
      mainWin(QWidget *, const char *name);
      ~mainWin();
      
      void initICQ(int);      
      void readMsgs();
      void WloggedIn();
      void Wdisconnected();
      void WupdateContact(unsigned long int uin);
      void Wmessage(MESSAGE *message);
      void Wurl(URL *url);
      void Wadded(ADDED *added);
      void WsearchResult(SEARCH_RESULT *result);
      
   	//void userConfigure(USER_CONFIGURATION &user_cfg);
        void callbackSetup(CALLBACK_FUNCTIONS &callback_functions);
        void timerEvent(QTimerEvent *);
        
//        void sendMsg(UIN uin, QString nick);
   private:
      int currentStatus;
      QAccel *accelKeys;      
      KStatusBar *statusBar;
      KMenuBar *menuBar;
      QPopupMenu *fileMenu,*editMenu,*viewMenu,*menu, *helpMenu;
      
//      KTreeList *listTree;
      QDate tijd;
      int type, cellRow,cellCol;
      KStatusBar *sb;
      QFrame *mainFrame,*viewFrame;
      Users *availList;      
      KToolBar *tb;
      KConfig *config;      
      void makeSound(int);      
      void showInfoA(int p);
      void showInfoO(int p);

   private slots:
      void reInitICQ();
   
      void discon();
      void conn();
      void setAway(int);
      void setBack(int);
      void setDND(int);
      void setNA(int);
      void setOccu(int);
      void setFFC(int);
      void setInvi(int);
      void paintEvent(QPaintEvent *);
      void quit();
      void help_about();
      void help_aboutXlib();
      void help_aboutQT();
      void configShow();
      
      
/*      void setWeekView();
*/      
      void resizeEvent(QResizeEvent *);
      
      
  

};

#endif
