// $Id: optionsdlg.cpp,v 1.10 1998/05/07 22:27:02 vespa Exp $

#include <qlabel.h>
#include <qgrpbox.h>
#include <qbttngrp.h>
#include <kapp.h>
#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include <libXicq.h>
#include "optionsdlg.h"
#include "optionsdlg.moc"
#include "kxicq.h"

extern USER_CONFIGURATION user_cfg;
extern void writeNewConfigFile(USER_CONFIGURATION *user_cfg);
extern struct kxicqConfig KxicqConfig;
extern KConfig *totalConfig;

///////////////////////////////////////////////////////////////////////////////

OptionsDialog::OptionsDialog( const char *title, QWidget *parent, char *name )
   : KPropDlg( KPropDlg::TREE, KPropDlg::OK | KPropDlg::CANCEL | KPropDlg::NEXT | KPropDlg::PREV,   title, 0, name )
   {
      // First page
      mainFrame = addPage( -1, "Personal Settings");
      setupMainTab();

      // Second page
      timeFrame = addPage( -1, "Server Settings");
      setupTimeTab();

      // Third page
      viewFrame = addPage( -1, "Message Settings");
      setupViewTab();

      //  viewFrame = addPage( -1, "Sending Settings");
      //  setupViewTab();



      // Layout
      setMinimumSize(475, 330);
      connect(this,SIGNAL(reInit()),parent,SLOT(reInitICQ()));
      connect(this,SIGNAL(configChanged()),this,SLOT(configSet()));
      showPage(mainFrame);
   }

///////////////////////////////////////////////////////////////////////////////

OptionsDialog::~OptionsDialog()
{
}

///////////////////////////////////////////////////////////////////////////////

void OptionsDialog::setupMainTab()
{

   QButtonGroup* dlgedit_ButtonGroup_2;
   dlgedit_ButtonGroup_2 = new QButtonGroup( mainFrame, "ButtonGroup_2" );
   dlgedit_ButtonGroup_2->setGeometry( 10, 130, 290, 110 );
   dlgedit_ButtonGroup_2->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_2->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_2->setFrameStyle( 49 );
   dlgedit_ButtonGroup_2->setTitle( "Personal Settings" );
   dlgedit_ButtonGroup_2->setAlignment( 1 );
   dlgedit_ButtonGroup_2->adjustSize();

   QButtonGroup* dlgedit_ButtonGroup_1;
   dlgedit_ButtonGroup_1 = new QButtonGroup(  mainFrame, "ButtonGroup_1" );
   dlgedit_ButtonGroup_1->setGeometry( 10, 10, 200, 110 );
   dlgedit_ButtonGroup_1->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_1->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_1->setFrameStyle( 49 );
   dlgedit_ButtonGroup_1->setTitle( "Your ICQ settings" );
   dlgedit_ButtonGroup_1->setAlignment( 1 );
   dlgedit_ButtonGroup_1->adjustSize();

   QLabel* dlgedit_Label_1;
   dlgedit_Label_1 = new QLabel(  mainFrame, "Label_1" );
   dlgedit_Label_1->setGeometry( 20, 30, 50, 20 );
   dlgedit_Label_1->setMinimumSize( 10, 10 );
   dlgedit_Label_1->setMaximumSize( 32767, 32767 );
   dlgedit_Label_1->setText( "UIN:" );
   dlgedit_Label_1->setAlignment( 289 );
   dlgedit_Label_1->setMargin( -1 );

   QLabel* dlgedit_Label_2;
   dlgedit_Label_2 = new QLabel(  mainFrame, "Label_2" );
   dlgedit_Label_2->setGeometry( 20, 60, 40, 20 );
   dlgedit_Label_2->setMinimumSize( 10, 10 );
   dlgedit_Label_2->setMaximumSize( 32767, 32767 );
   dlgedit_Label_2->setText( "Nick:" );
   dlgedit_Label_2->setAlignment( 289 );
   dlgedit_Label_2->setMargin( -1 );


   dlgedit_uinEdit = new QLineEdit(  mainFrame, "uinEdit" );
   dlgedit_uinEdit->setGeometry( 80, 30, 100, 23 );
   dlgedit_uinEdit->setMinimumSize( 10, 10 );
   dlgedit_uinEdit->setMaximumSize( 32767, 32767 );
   QString tmp;
   tmp.sprintf("%ld",user_cfg.uin);
   dlgedit_uinEdit->setText( tmp.data() );
   dlgedit_uinEdit->setMaxLength( 32767 );
   dlgedit_uinEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_uinEdit->setFrame( TRUE );


   dlgedit_nickEdit = new QLineEdit( mainFrame, "nickEdit" );
   dlgedit_nickEdit->setGeometry( 80, 60, 100, 23 );
   dlgedit_nickEdit->setMinimumSize( 10, 10 );
   dlgedit_nickEdit->setMaximumSize( 32767, 32767 );
   dlgedit_nickEdit->setText( user_cfg.nick );
   dlgedit_nickEdit->setMaxLength( 32767 );
   dlgedit_nickEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_nickEdit->setFrame( TRUE );

   QLabel* dlgedit_Label_3;
   dlgedit_Label_3 = new QLabel( mainFrame, "Label_3" );
   dlgedit_Label_3->setGeometry( 20, 90, 60, 20 );
   dlgedit_Label_3->setMinimumSize( 10, 10 );
   dlgedit_Label_3->setMaximumSize( 32767, 32767 );
   dlgedit_Label_3->setText( "Password:" );
   dlgedit_Label_3->setAlignment( 289 );
   dlgedit_Label_3->setMargin( -1 );


   dlgedit_passwdEdit = new QLineEdit( mainFrame, "passwdEdit" );
   dlgedit_passwdEdit->setGeometry( 80, 90, 100, 23 );
   dlgedit_passwdEdit->setMinimumSize( 10, 10 );
   dlgedit_passwdEdit->setMaximumSize( 32767, 32767 );
   dlgedit_passwdEdit->setText( user_cfg.password );
   //   printf("1\n");
   //   printf("%s\n",dlgedit_passwdEdit->text());
   dlgedit_passwdEdit->setMaxLength( 32767 );
   dlgedit_passwdEdit->setEchoMode( QLineEdit::Password );
   dlgedit_passwdEdit->setFrame( TRUE );

   QLabel* dlgedit_Label_4;
   dlgedit_Label_4 = new QLabel( mainFrame, "Label_4" );
   dlgedit_Label_4->setGeometry( 20, 150, 100, 20 );
   dlgedit_Label_4->setMinimumSize( 10, 10 );
   dlgedit_Label_4->setMaximumSize( 32767, 32767 );
   dlgedit_Label_4->setText( "First Name:" );
   dlgedit_Label_4->setAlignment( 289 );
   dlgedit_Label_4->setMargin( -1 );

   QLabel* dlgedit_Label_5;
   dlgedit_Label_5 = new QLabel( mainFrame, "Label_5" );
   dlgedit_Label_5->setGeometry( 20, 180, 100, 20 );
   dlgedit_Label_5->setMinimumSize( 10, 10 );
   dlgedit_Label_5->setMaximumSize( 32767, 32767 );
   dlgedit_Label_5->setText( "Last Name:" );
   dlgedit_Label_5->setAlignment( 289 );
   dlgedit_Label_5->setMargin( -1 );

   QLabel* dlgedit_Label_6;
   dlgedit_Label_6 = new QLabel( mainFrame, "Label_6" );
   dlgedit_Label_6->setGeometry( 20, 210, 100, 20 );
   dlgedit_Label_6->setMinimumSize( 10, 10 );
   dlgedit_Label_6->setMaximumSize( 32767, 32767 );
   dlgedit_Label_6->setText( "E Mail adress:" );
   dlgedit_Label_6->setAlignment( 289 );
   dlgedit_Label_6->setMargin( -1 );


   dlgedit_firstNameEdit = new QLineEdit( mainFrame, "firstNameEdit" );
   dlgedit_firstNameEdit->setGeometry( 110, 150, 170, 23 );
   dlgedit_firstNameEdit->setMinimumSize( 10, 10 );
   dlgedit_firstNameEdit->setMaximumSize( 32767, 32767 );
   dlgedit_firstNameEdit->setText( user_cfg.firstName );
   dlgedit_firstNameEdit->setMaxLength( 32767 );
   dlgedit_firstNameEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_firstNameEdit->setFrame( TRUE );



   dlgedit_lastNameEdit = new QLineEdit( mainFrame, "lastNameEdit" );
   dlgedit_lastNameEdit->setGeometry( 110, 180, 170, 23 );
   dlgedit_lastNameEdit->setMinimumSize( 10, 10 );
   dlgedit_lastNameEdit->setMaximumSize( 32767, 32767 );
   dlgedit_lastNameEdit->setText( user_cfg.lastName );
   dlgedit_lastNameEdit->setMaxLength( 32767 );
   dlgedit_lastNameEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_lastNameEdit->setFrame( TRUE );


   dlgedit_emailEdit = new QLineEdit( mainFrame, "emailEdit" );
   dlgedit_emailEdit->setGeometry( 110, 210, 170, 23 );
   dlgedit_emailEdit->setMinimumSize( 10, 10 );
   dlgedit_emailEdit->setMaximumSize( 32767, 32767 );
   dlgedit_emailEdit->setText( user_cfg.email );
   dlgedit_emailEdit->setMaxLength( 32767 );
   dlgedit_emailEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_emailEdit->setFrame( TRUE );




}

///////////////////////////////////////////////////////////////////////////////

void OptionsDialog::setupTimeTab()
{


   QButtonGroup* dlgedit_ButtonGroup_4;
   dlgedit_ButtonGroup_4 = new QButtonGroup( timeFrame, "ButtonGroup_4" );
   dlgedit_ButtonGroup_4->setGeometry( 10, 140, 330, 100 );
   dlgedit_ButtonGroup_4->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_4->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_4->setFrameStyle( 49 );
   dlgedit_ButtonGroup_4->setTitle( "Startup Options" );
   dlgedit_ButtonGroup_4->setAlignment( 1 );

   QButtonGroup* dlgedit_ButtonGroup_3;
   dlgedit_ButtonGroup_3 = new QButtonGroup( timeFrame, "ButtonGroup_3" );
   dlgedit_ButtonGroup_3->setGeometry( 10, 10, 330, 120 );
   dlgedit_ButtonGroup_3->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_3->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_3->setFrameStyle( 49 );
   dlgedit_ButtonGroup_3->setTitle( "ICQ server" );
   dlgedit_ButtonGroup_3->setAlignment( 1 );

   QLabel* dlgedit_Label_7;
   dlgedit_Label_7 = new QLabel( timeFrame, "Label_7" );
   dlgedit_Label_7->setGeometry( 240, 90, 40, 20 );
   dlgedit_Label_7->setMinimumSize( 10, 10 );
   dlgedit_Label_7->setMaximumSize( 32767, 32767 );
   dlgedit_Label_7->setText( "Port:" );
   dlgedit_Label_7->setAlignment( 289 );
   dlgedit_Label_7->setMargin( -1 );

   QLabel* dlgedit_Label_8;
   dlgedit_Label_8 = new QLabel( timeFrame, "Label_8" );
   dlgedit_Label_8->setGeometry( 20, 90, 70, 20 );
   dlgedit_Label_8->setMinimumSize( 10, 10 );
   dlgedit_Label_8->setMaximumSize( 32767, 32767 );
   dlgedit_Label_8->setText( "Server:" );
   dlgedit_Label_8->setAlignment( 289 );
   dlgedit_Label_8->setMargin( -1 );


   dlgedit_serverEdit = new QLineEdit( timeFrame, "serverEdit" );
   dlgedit_serverEdit->setGeometry( 70, 90, 160, 20 );
   dlgedit_serverEdit->setMinimumSize( 10, 10 );
   dlgedit_serverEdit->setMaximumSize( 32767, 32767 );
   dlgedit_serverEdit->setText( user_cfg.serverAddr );
   dlgedit_serverEdit->setMaxLength( 32767 );
   dlgedit_serverEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_serverEdit->setFrame( TRUE );

   dlgedit_portEdit = new QLineEdit( timeFrame, "portEdit" );
   dlgedit_portEdit->setGeometry( 280, 90, 40, 20 );
   dlgedit_portEdit->setMinimumSize( 10, 10 );
   dlgedit_portEdit->setMaximumSize( 32767, 32767 );
   QString tmp;
   tmp.sprintf("%d",  user_cfg.serverPort );

   dlgedit_portEdit->setText(tmp.data());
   dlgedit_portEdit->setMaxLength( 32767 );
   dlgedit_portEdit->setEchoMode( QLineEdit::Normal );
   dlgedit_portEdit->setFrame( TRUE );

   dlgedit_icqServers = new QComboBox( FALSE, timeFrame, "icqServers" );
   dlgedit_icqServers->setGeometry( 30, 40, 280, 20 );
   dlgedit_icqServers->setMinimumSize( 10, 10 );
   dlgedit_icqServers->setMaximumSize( 32767, 32767 );
   connect( dlgedit_icqServers, SIGNAL(activated(const char*)), SLOT(updateServer(const char*)) );
   dlgedit_icqServers->setSizeLimit( 10 );
   dlgedit_icqServers->setAutoResize( FALSE );
   dlgedit_icqServers->insertItem("icq.mirabilis.com");
   dlgedit_icqServers->insertItem("icq1.mirabilis.com");
   dlgedit_icqServers->insertItem("icq2.mirabilis.com");
   dlgedit_icqServers->insertItem("icq3.mirabilis.com");
   dlgedit_icqServers->insertItem("icq4.mirabilis.com");
   dlgedit_icqServers->insertItem("icq5.mirabilis.com");

   QLabel* dlgedit_Label_9;
   dlgedit_Label_9 = new QLabel( timeFrame, "Label_9" );
   dlgedit_Label_9->setGeometry( 20, 170, 50, 20 );
   dlgedit_Label_9->setMinimumSize( 10, 10 );
   dlgedit_Label_9->setMaximumSize( 32767, 32767 );
   dlgedit_Label_9->setText( "Status:" );
   dlgedit_Label_9->setAlignment( 289 );
   dlgedit_Label_9->setMargin( -1 );


   dlgedit_startStatup = new QComboBox( FALSE, timeFrame, "startStatup" );
   dlgedit_startStatup->setGeometry( 60, 170, 100, 20 );
   dlgedit_startStatup->setMinimumSize( 10, 10 );
   dlgedit_startStatup->setMaximumSize( 32767, 32767 );
   dlgedit_startStatup->setSizeLimit( 10 );
   dlgedit_startStatup->setAutoResize( FALSE );
   dlgedit_startStatup->insertItem( "Available" );
   dlgedit_startStatup->insertItem( "Away" );
   dlgedit_startStatup->insertItem( "DND" );
   dlgedit_startStatup->insertItem( "N/A" );
   dlgedit_startStatup->insertItem( "Occupied" );
   dlgedit_startStatup->insertItem( "Free for Chat" );
   dlgedit_startStatup->insertItem( "Invisible" );
   dlgedit_startStatup->setCurrentItem(user_cfg.status);   // -1 !!!!!!


   dlgedit_autoConnect = new QCheckBox( timeFrame, "autoConnect" );
   dlgedit_autoConnect->setGeometry( 180, 160, 110, 15 );
   dlgedit_autoConnect->setMinimumSize( 10, 10 );
   dlgedit_autoConnect->setMaximumSize( 32767, 32767 );
   dlgedit_autoConnect->setText( "Auto Connect" );
   dlgedit_autoConnect->setAutoRepeat( FALSE );
   dlgedit_autoConnect->setAutoResize( FALSE );
   dlgedit_autoConnect->setChecked( KxicqConfig.autoConnect==0 ? FALSE : TRUE );

   dlgedit_showOffline = new QCheckBox( timeFrame, "showOffline" );
   dlgedit_showOffline->setGeometry( 180, 180, 155, 15 );
   dlgedit_showOffline->setMinimumSize( 10, 10 );
   dlgedit_showOffline->setMaximumSize( 32767, 32767 );
   dlgedit_showOffline->setText( "Show Offline (xicq only)" );
   dlgedit_showOffline->setAutoRepeat( FALSE );
   dlgedit_showOffline->setAutoResize( FALSE );
   dlgedit_showOffline->setChecked( user_cfg.showoffline == 0 ? FALSE : TRUE );

   dlgedit_ButtonGroup_4->insert( dlgedit_autoConnect );

}

///////////////////////////////////////////////////////////////////////////////

void OptionsDialog::setupViewTab()
{
   // I'm working on this section. Expect major revision shortly. (CJB)

   //   QLabel *dummy = new QLabel("Under Construction", viewFrame);
   //   dummy->adjustSize();

   QButtonGroup* dlgedit_ButtonGroup_1;
   dlgedit_ButtonGroup_1 = new QButtonGroup( viewFrame, "ButtonGroup_1" );
   dlgedit_ButtonGroup_1->setGeometry( 10, 10, 330, 70 );
   dlgedit_ButtonGroup_1->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_1->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_1->setFrameStyle( 49 );
   dlgedit_ButtonGroup_1->setTitle( "Browser" );
   dlgedit_ButtonGroup_1->setAlignment( 1 );


   dlgedit_browser = new QLineEdit( viewFrame, "browser" );
   dlgedit_browser->setGeometry( 100, 50, 230, 20 );
   dlgedit_browser->setMinimumSize( 10, 10 );
   dlgedit_browser->setMaximumSize( 32767, 32767 );
   QString tmp(1024);
   tmp.sprintf("%s",KxicqConfig.browser);
   dlgedit_browser->setText( tmp.data() );
   dlgedit_browser->setMaxLength( 32767 );
   dlgedit_browser->setEchoMode( QLineEdit::Normal );
   dlgedit_browser->setFrame( TRUE );
   dlgedit_browser->setEnabled( KxicqConfig.typeBrowser==1 ? TRUE : FALSE);


   dlgedit_typeBrowser_1 = new QRadioButton( viewFrame, "typeBrowser_1" );
   dlgedit_typeBrowser_1->setGeometry( 30, 30, 100, 20 );
   dlgedit_typeBrowser_1->setMinimumSize( 10, 10 );
   dlgedit_typeBrowser_1->setMaximumSize( 32767, 32767 );
   dlgedit_typeBrowser_1->setText( "KFM" );
   dlgedit_typeBrowser_1->setAutoRepeat( FALSE );
   dlgedit_typeBrowser_1->setAutoResize( FALSE );
   dlgedit_typeBrowser_1->setChecked( KxicqConfig.typeBrowser==0 ? TRUE : FALSE  );
   connect(dlgedit_typeBrowser_1,SIGNAL(toggled(bool)),this,SLOT(toggleBrowserEdit(bool)));

   dlgedit_typeBrowser_2 = new QRadioButton( viewFrame, "typeBrowser_2" );
   dlgedit_typeBrowser_2->setGeometry( 30, 50, 60, 20 );
   dlgedit_typeBrowser_2->setMinimumSize( 10, 10 );
   dlgedit_typeBrowser_2->setMaximumSize( 32767, 32767 );
   dlgedit_typeBrowser_2->setText( "Other :" );
   dlgedit_typeBrowser_2->setAutoRepeat( FALSE );
   dlgedit_typeBrowser_2->setAutoResize( FALSE );
   dlgedit_typeBrowser_2->setChecked( KxicqConfig.typeBrowser==1 ? TRUE : FALSE  );

   dlgedit_ButtonGroup_1->insert( dlgedit_typeBrowser_1 );
   dlgedit_ButtonGroup_1->insert( dlgedit_typeBrowser_2 );

   QButtonGroup* dlgedit_ButtonGroup_2;
   dlgedit_ButtonGroup_2 = new QButtonGroup( viewFrame, "ButtonGroup_2" );
   dlgedit_ButtonGroup_2->setGeometry( 10, 90, 330, 70 );
   dlgedit_ButtonGroup_2->setMinimumSize( 10, 10 );
   dlgedit_ButtonGroup_2->setMaximumSize( 32767, 32767 );
   dlgedit_ButtonGroup_2->setFrameStyle( 49 );
   dlgedit_ButtonGroup_2->setTitle( "Sound" );
   dlgedit_ButtonGroup_2->setAlignment( 1 );

   dlgedit_makeSound = new QCheckBox( viewFrame, "makeSound" );
   dlgedit_makeSound->setGeometry( 30, 110, 195, 15 );
   dlgedit_makeSound->setMinimumSize( 10, 10 );
   dlgedit_makeSound->setMaximumSize( 32767, 32767 );
   dlgedit_makeSound->setText( "Beep on recieved Message" );
   dlgedit_makeSound->setAutoRepeat( FALSE );
   dlgedit_makeSound->setAutoResize( FALSE );
   dlgedit_makeSound->setChecked( KxicqConfig.sound == 0 ? FALSE : TRUE );
   connect(dlgedit_makeSound,SIGNAL(toggled(bool)),this,SLOT(toggleAlwaysSound(bool)));

   dlgedit_alwaysSound = new QCheckBox( viewFrame, "alwaysSound" );
   dlgedit_alwaysSound->setGeometry( 30, 135, 195, 15 );
   dlgedit_alwaysSound->setMinimumSize( 10, 10 );
   dlgedit_alwaysSound->setMaximumSize( 32767, 32767 );
   dlgedit_alwaysSound->setText( "Even when Away etc." );
   dlgedit_alwaysSound->setAutoRepeat( FALSE );
   dlgedit_alwaysSound->setAutoResize( FALSE );
   dlgedit_alwaysSound->setChecked( KxicqConfig.alwaysSound == 0 ? FALSE : TRUE );
   dlgedit_alwaysSound->setEnabled(KxicqConfig.sound == 1 ? TRUE : FALSE);

}

///////////////////////////////////////////////////////////////////////////////

void OptionsDialog::setConfig()
{
   configSet();
}

void OptionsDialog::configSet()
{

   USER_CONFIGURATION nuser_cfg;

   asprintf(&nuser_cfg.nick,"%s",dlgedit_nickEdit->text());
   asprintf(&nuser_cfg.password,"%s",dlgedit_passwdEdit->text());
   nuser_cfg.uin=atol(dlgedit_uinEdit->text());
   asprintf(&nuser_cfg.firstName,"%s",dlgedit_firstNameEdit->text());
   asprintf(&nuser_cfg.lastName,"%s",dlgedit_lastNameEdit->text());
   asprintf(&nuser_cfg.email,"%s",dlgedit_emailEdit->text());
   asprintf(&nuser_cfg.serverAddr,"%s",dlgedit_serverEdit->text());

   nuser_cfg.serverPort=atoi(dlgedit_portEdit->text());
   nuser_cfg.status=dlgedit_startStatup->currentItem();
   nuser_cfg.showoffline=dlgedit_showOffline->isChecked()==TRUE ? 1 : 0;

   writeNewConfigFile(&nuser_cfg);
   free(nuser_cfg.nick);
   free(nuser_cfg.password);
   free(nuser_cfg.firstName);
   free(nuser_cfg.lastName);
   free(nuser_cfg.email);
   free(nuser_cfg.serverAddr);

   if (KxicqConfig.browser	!= NULL) free(KxicqConfig.browser);
   asprintf(&KxicqConfig.browser,"%s",dlgedit_browser->text());
   KxicqConfig.typeBrowser=dlgedit_typeBrowser_2->isChecked() ==TRUE ? 1 : 0;
   KxicqConfig.autoConnect=dlgedit_autoConnect->isChecked() ==TRUE ? 1 : 0;
   KxicqConfig.sound=dlgedit_makeSound->isChecked() ==TRUE ? 1 : 0;
   KxicqConfig.alwaysSound=dlgedit_alwaysSound->isChecked() ==TRUE ? 1 : 0;
   


   totalConfig->setGroup("Startup");
   totalConfig->writeEntry("autoconnect",KxicqConfig.autoConnect);
   totalConfig->setGroup("Browser");
   totalConfig->writeEntry("type",KxicqConfig.typeBrowser);
   totalConfig->writeEntry("programm",KxicqConfig.browser);
   totalConfig->setGroup("Sound");
   totalConfig->writeEntry("makeSound",KxicqConfig.sound);
   totalConfig->writeEntry("alwaysSound",KxicqConfig.alwaysSound);
   
   totalConfig->sync();
   

   emit reInit();
   accept();

}

void OptionsDialog::toggleBrowserEdit(bool t)
{
   if (t)   dlgedit_browser->setEnabled(FALSE);
   else     dlgedit_browser->setEnabled(TRUE);
}
void OptionsDialog::toggleAlwaysSound(bool t)
{
   if (t)   dlgedit_alwaysSound->setEnabled(TRUE);
   else     dlgedit_alwaysSound->setEnabled(FALSE);
}
void OptionsDialog::updateServer(const char *t)
{
   dlgedit_serverEdit->setText( t );
}


///////////////////////////////////////////////////////////////////////////////

