
// $Id: optionsdlg.h,v 1.8 1998/05/07 22:27:03 vespa Exp $
// (C) 1998 by Preston Brown, Fester Zigterman, and Christopher Beard

#ifndef __OPTION_H__
#define __OPTION_H__

#include <qtabdlg.h>
#include <qframe.h>
#include <qlined.h>
#include <qcombo.h>
#include <qchkbox.h>
#include <kconfig.h>
#include <qradiobt.h>
#include <qpushbt.h>
#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include "kpropdlg.h"
//#include "calobject.h"

class OptionsDialog : public KPropDlg
{
      Q_OBJECT
   public:
/** Initialize dialog and pages */
      OptionsDialog( const char *title, QWidget *parent = 0, char *name = 0 );
      ~OptionsDialog();

   	
      protected slots:
/** Write the config to the KConfig object */
      
      void configSet();

   signals:
      void reInit();

   protected:
/** These methods create the page contents */
      void setupMainTab();
      void setupTimeTab();
      void setupViewTab();

   private:
      int jaja;
      QLineEdit* dlgedit_lastNameEdit;
      QLineEdit* dlgedit_firstNameEdit;
      QLineEdit* dlgedit_uinEdit;
      QLineEdit* dlgedit_passwdEdit;
      QLineEdit* dlgedit_nickEdit;
      QLineEdit* dlgedit_emailEdit;

      QLineEdit* dlgedit_serverEdit;
      QLineEdit* dlgedit_portEdit;
      QComboBox* dlgedit_icqServers;
      QComboBox* dlgedit_startStatup;
      QCheckBox* dlgedit_autoConnect;
      QCheckBox* dlgedit_showOffline;
      QCheckBox* dlgedit_makeSound;
      QCheckBox* dlgedit_alwaysSound;


      QLineEdit* dlgedit_browser;
      QRadioButton* dlgedit_typeBrowser_1;
      QRadioButton* dlgedit_typeBrowser_2;


      QFrame *mainFrame;
      QFrame *timeFrame;
      QFrame *viewFrame;
      void setConfig();
      
   private slots:
      void toggleAlwaysSound(bool);   
      void toggleBrowserEdit(bool);
      void updateServer(const char*);
/** pointer to kapp->getConfig(); */
};

#endif
