

#include <qframe.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <kiconloader.h>
#include <qwmatrix.h>
#include <qrect.h>
#include <qwmatrix.h>
#include <qpicture.h>
#include <qdict.h>
#include <qintdict.h>
//#include <stdio.h>

#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include "users.h"
#include "kxicq.h"
#include "dialogs.h"


#define ID_POPUP_MSG 1
#define ID_POPUP_CHAT 2
#define ID_POPUP_INFO 3
#define ID_POPUP_DELETE 4
#define ID_POPUP_ADD 5

extern int logged_on;
extern mainWin *mainW;
extern KApplication *mainApp;
extern QList<MSG> userMsg;

tab::tab(int t,QWidget *parent, const char *name, int col)
   : KTabListBox(parent, name, col)
   {
      par=parent;
      QPixmap pixmap;
      status=t;
      pos=0;
      KTabListBox::lbox.installEventFilter(this);

      KIconLoader *iconL = kapp->getIconLoader();

      dict().insert("M",new QPixmap(iconL->loadIcon("filemail.xpm")));
      dict().insert("F",new QPixmap(iconL->loadIcon("attach.xpm")));
      dict().insert("Available",new QPixmap(iconL->loadIcon("green-bullet.xpm")));
      dict().insert("R",new QPixmap(iconL->loadIcon("read.xpm")));
      dict().insert("Away",new QPixmap(iconL->loadIcon("away.xpm")));
      dict().insert("N/A",new QPixmap(iconL->loadIcon("NA.xpm")));
      dict().insert("DND",new QPixmap(iconL->loadIcon("DND.xpm")));
      dict().insert("Occupied",new QPixmap(iconL->loadIcon("occupied.xpm")));
      dict().insert("Free for chat",new QPixmap(iconL->loadIcon("ffc.xpm")));
      dict().insert("Invisible",new QPixmap(iconL->loadIcon("invisible.xpm")));


      menu=new QPopupMenu;
      pixmap=iconL->loadIcon("send.xpm");
      menu->insertItem(pixmap,"&Message",this,SLOT(sendMSG()));
      menu->insertItem(pixmap,"&Url",this,SLOT(sendURL()));

      //      menu->insertItem("&Chat",ID_POPUP_CHAT);
      menu->insertItem("&Info",this,SLOT(showInfo()));
      //      menu->insertSeparator();
      //      pixmap=iconL->loadIcon("kmmsgdel.xpm");
      //      menu->insertItem(pixmap,"&Delete",ID_POPUP_DELETE);
      //      menu->insertItem("&Add",ID_POPUP_ADD);

      //      connect(menu,SIGNAL(activated(int)),SLOT(menuCallBack(int)));
      connect(this,SIGNAL(selected(int,int)),SLOT(mouseDoubleClick(int,int)));

   }

tab::~tab()
{
   delete menu;
}

void tab::showInfo()
{
   int c;
   setCurrentItem(pos);
   if (status==0)
      c=2;
   else
      c=3;

   QString tmp;
   tmp=text(pos,c);
   if (atol(tmp)<=0) return;
   if (logged_on) send_uinSearch(atoi(tmp.data())); else loggedon();
}
int tt=0;
void tab::sendMSG()
{
   int c;
   setCurrentItem(pos);
   if (status==0)
      c=2;
   else
      c=3;

   QString tmp;
   tmp=text(pos,c);
   if (atol(tmp)<=0) return;
   Mail *myMsgWin;

   myMsgWin=new Mail(atol(tmp),mainW,"msgedit");

   if (!myMsgWin->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete myMsgWin;
}
void tab::sendURL()
{
   int c;
   setCurrentItem(pos);
   if (status==0)
      c=2;
   else
      c=3;

   QString tmp;
   tmp=text(pos,c);
   if (atol(tmp)<=0) return;
   sendUrl *myMsgWin;

   myMsgWin=new sendUrl(atol(tmp),mainW,"msgedit");

   if (!myMsgWin->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete myMsgWin;
}



bool tab::eventFilter(QObject*, QEvent *e)
{
   if (e->type() == Event_MouseButtonPress)
   {
      QMouseEvent *ev = (QMouseEvent *) e;
      doMousePressEvent(ev);
      return TRUE;
   }
   return FALSE;
}

void tab::mouseDoubleClick(int e, int)
{
   pos=e;
   showMsg();
}

void tab::doMousePressEvent(QMouseEvent *e)
{
   int x,y;
   x=findCol(e->x());
   y=findRow(e->y());
   //   printf("%d -> %d\n",e->y(),y);
   //   hide();
   if (y>=0 && x>=0 && y<=numRows())
   {
      unmarkAll();
      markItem(y);
      //      activate_signal(activated(x,y));
      //      availList->unSelectAll(status);

      if (e->button() == RightButton)
      {
	 pos=y;
	 menu->popup(QCursor::pos());

      }
      if (e->button() == MidButton)
      {
	 pos=y;
	 showMsg();
      }
      repaint();
   }

}
////////////////// moet beter ! //////////////////
void tab::showMsg()
{
   int c;
   setCurrentItem(pos);
   if (status==0)
      c=2;
   else
      c=3;

   QString tmp;
   tmp=text(pos,c);
   UIN uin=atoi(tmp.data());

   if (ifMsg(uin)==0)
   {
      return;
   }

   Read *tmpR;
   tmpR=new Read(uin,mainW);

   if (!tmpR->exec())
   {
      return;
   }
   mainApp->processEvents();
   mainApp->flushX();

   delete tmpR;
   emit setUnRead(uin);

   //  if (!askRead(uin))
   //   {
   //      changeItemPart("R",pos,c-1);
   //   }

}




Users::Users(QWidget* parent, const char* name)
   : QWidget(parent,name)
   {

      offl=new tab(0,this,name,4);
      offl->setColumn(0,i18n("Offline Name's"),100);
      offl->setColumn(1,i18n("R"),28,KTabListBox::PixmapColumn);
      offl->setColumn(2,i18n(""),0);
      connect(offl,SIGNAL(highlighted(int,int)),this,SLOT(highlight1(int,int)));
      connect(offl,SIGNAL(setUnRead(UIN)),this,SLOT(doSetUnRead(UIN)));
      avail=new tab(1,this,name,5);
      avail->setColumn(0,i18n("Online Name's"),100);
      avail->setColumn(1,i18n("S"),28,KTabListBox::PixmapColumn);
      avail->setColumn(2,i18n("R"),28,KTabListBox::PixmapColumn);
      avail->setColumn(3,i18n(""),0);
      connect(avail,SIGNAL(highlighted(int,int)),this,SLOT(highlight2(int,int)));
      connect(avail,SIGNAL(setUnRead(UIN)),this,SLOT(doSetUnRead(UIN)));
      repaint();
      updateView();
      offl->show();

   }

Users::~Users()
{
   delete offl;
   delete avail;

}
void Users::unSelectAll(int t)
{
   if (t==0)
   {
      offl->unmarkAll();
   }
   else
   {
      avail->unmarkAll();
   }
}

void Users::highlight1(int, int)
{
   avail->unmarkAll();
}
void Users::highlight2(int, int)
{
   offl->unmarkAll();
}
void Users::insertItem(UIN status, QString nick,UIN uin,int r,int ir)
{
   if (status!=STATUS_OFFLINE)
   {
      avail->setAutoUpdate(FALSE);
      avail->insertItem(nick,-1);
      avail->setCurrentItem(avail->count()-1);


      QString tmp;
      tmp.sprintf("%ld",uin);
      avail->changeItemPart(contact_status2str(status),avail->currentItem(),1);
      avail->changeItemPart(tmp,avail->currentItem(),3);
      if (r) avail->changeItemPart("M",avail->currentItem(),2);
      else
	 if (ir) avail->changeItemPart("R",avail->currentItem(),2);
      avail->setAutoUpdate(TRUE);
      avail->repaint();
   }
   else
   {
      offl->setAutoUpdate(FALSE);
      offl->insertItem(nick,-1);
      offl->setCurrentItem(offl->count()-1);
      QString tmp;
      tmp.sprintf("%ld",uin);
      offl->changeItemPart(tmp,offl->currentItem(),2);
      if (r) offl->changeItemPart("M",offl->currentItem(),1);
      else
	 if (ir) offl->changeItemPart("R",offl->currentItem(),1);
      offl->setAutoUpdate(TRUE);
      offl->repaint();
   }


}

void Users::changeItem(UIN uin, QString nick, UIN status)
{
   unsigned int t;
   QString tmp1(10);
   for (t=0; t<offl->count(); t++)
   {
      if ((UIN)atol(offl->text(t,2))==uin)
      {
	 if ((UIN)status!=(UIN)STATUS_OFFLINE)
	 {
	    avail->setAutoUpdate(FALSE);
	    offl->setAutoUpdate(FALSE);
	    tmp1=offl->text(t,1);
            offl->setCurrentItem(t);
	    offl->removeItem(offl->currentItem());
	    avail->insertItem(nick,-1);
	    avail->setCurrentItem(avail->count()-1);

	    QString tmp(15);
	    tmp.sprintf("%ld",uin);
	    avail->changeItemPart(contact_status2str(status),avail->currentItem(),1);
	    avail->changeItemPart(tmp,avail->currentItem(),3);
	    avail->changeItemPart(tmp1.data(),avail->currentItem(),2);
	    offl->setAutoUpdate(TRUE);
	    avail->setAutoUpdate(TRUE);
	    offl->repaint();
	    avail->repaint();
	    return;
	 }
      }
   }
   for (t=0; t<=avail->count()-1; t++)
   {
      if ((UIN)atol(avail->text(t,3))==uin)
      {
	 if ((UIN)status!=(UIN)STATUS_OFFLINE)
	 {
	    avail->setAutoUpdate(FALSE);
	    avail->setCurrentItem(t);
	    avail->changeItemPart(contact_status2str(status),avail->currentItem(),1);
	    avail->setAutoUpdate(TRUE);
	    avail->repaint();
	    return;
	 }
	 else
	 {
	    offl->setAutoUpdate(FALSE);
	    tmp1=avail->text(t,2);
	    avail->removeItem(t);
	    offl->insertItem(nick,-1);
	    offl->setCurrentItem(offl->count()-1);
	    QString tmp(15);
	    tmp.sprintf("%ld",uin);
	    offl->changeItemPart(tmp,offl->currentItem(),2);
	    offl->changeItemPart(tmp1.data(),offl->currentItem(),1);
	    offl->setAutoUpdate(TRUE);
	    offl->repaint();
	    return;
	 }
      }
   }
}

int Users::addItem(UIN uin)
{
   unsigned int t,s=0;
   for (t=0; t<avail->count(); t++)
   {
      if ((UIN)atol(avail->text(t,3))==uin)
      {
	 s++;
	 avail->changeItemPart("M",t,2);
	 return 1;
      }
   }
   if (s==0)
   {
      for (t=0; t<offl->count(); t++)
      {
	 if ((UIN)atol(offl->text(t,2))==uin)
	 {
	    offl->changeItemPart("M",t,1);
	    return 1;
	 }
      }
   }
   s=0;
   for (t=0; t<avail->count(); t++)
   {
      if (atol(avail->text(t,3))==-1)
      {
	 s++;
	 avail->changeItemPart("M",t,2);
	 return 1;
      }
   }
   for (t=0; t<avail->count(); t++)
   {
      if (atol(avail->text(t,3))==TYPE_SERVER)
      {
	 avail->changeItemPart("M",t,2);
	 return 1;
      }
   }
   return 0;
}

void Users::doSetUnRead(UIN uin)
{
   unsigned int t;

   if (!askRead(uin))
   {
      for (t=0; t<avail->count(); t++)
      {
	 if ((UIN)atol(avail->text(t,3))==uin)
	 {
	    avail->changeItemPart("R",t,2);
	    return;
	 }
      }
      for (t=0; t<offl->count(); t++)
      {
	 if ((UIN)atol(offl->text(t,2))==uin)
	 {
	    offl->changeItemPart("R",t,1);
	    return;
	 }
      }
      for (t=0; t<avail->count(); t++)
      {
	 if (atol(avail->text(t,3))==-1)
	 {
	    avail->changeItemPart("R",t,2);
	    return;
	 }
      }
      for (t=0; t<avail->count(); t++)
      {
	 if (atol(avail->text(t,3))==TYPE_SERVER)
	 {
	    avail->changeItemPart("R",t,2);
	    return;
	 }
      }
      return;
   }
}

bool Users::eventFilter(QObject *obj, QEvent *event)
{
   if (event->type() == Event_MouseButtonPress)
   {
      //      avail->unmarkAll();
      //      offl->unmarkAll();
      //      return TRUE;
   }
   return FALSE;
}


void Users::updateView()
{
   repaint();
}

void Users::mousePressEvent(QMouseEvent *m)
{
}
void Users::doMouseEvent(QMouseEvent *)
{
}
void Users::resizeEvent(QResizeEvent *)
{
   offl->move(0,0);
   offl->resize((width()/2)-2,height());
   avail->move((width()/2)+4,0);
   avail->resize((width()/2)-4,height());
   //   offl->setColumnWidth(1,offl->width()-120);
   //   avail->setColumnWidth(2,avail->width()-152);

}
