#ifndef TABLE_H
#define TABLE_H
#include <qaccel.h>
#include <qkeycode.h>
#include <qlabel.h>
#include <qbttngrp.h>
#include <qpushbt.h>
#include <qprogbar.h>
#include <qlayout.h>
#include <qpopmenu.h>
#include <unistd.h>
#include <stdlib.h>
#include <qwindow.h>
#include <qlabel.h>
#include <qbitmap.h>
#include <kwm.h>
#include <kapp.h>
#include <kprogress.h>
#include <qpushbt.h>
#include <qpainter.h>
#include <qpicture.h>
#include <qwidget.h>
#include <qpaintd.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <qcolor.h>
#include <kiconloader.h>
#include <ctype.h>
#include <kstatusbar.h>
#include <kmenubar.h>
#include <ktreelist.h>
#include <qdatetm.h>
#include <ktablistbox.h>

#include <qtablevw.h>
#include <qdatetm.h>
#include <qscrbar.h>
#include <qwidget.h>
#include <ktablistbox.h>
#include <qobject.h>
#include <qevent.h>
#include <qpopmenu.h>
#include <qpaintd.h>



#define ID_MSG_READ 1
#define ID_MSG_NOTREAD 0
#define ID_IS_FILE 2
#define ID_IS_MSG 3

#define TYPE_MSG 1
#define TYPE_URL 2
#define TYPE_ADDED 3
#define TYPE_SEARCH 4

#if defined(VERSION)
#undef VERSION
#endif
#if defined(DEBUG)
#undef DEBUG
#endif
#include <libXicq.h>

#define UIN unsigned long int


class MSG
{
   public:
      MSG(UIN u=0) {  uin=u; read=0; tofree=0;  };
      ~MSG() {

	     };
      void setUin(UIN u) {  uin=u;  };
      void setMsg(MESSAGE m) {  msg=m; type=TYPE_MSG;  };
      void setUrl(URL m) {  url=m; type=TYPE_URL;  };
      void setAdded(ADDED m) {  add=m; type=TYPE_ADDED;  };
      void setSearch(SEARCH_RESULT m) {  sr=m; type=TYPE_SEARCH;  };

      void setRead(int r) {  read=r;  };
      void setrMsg(char *m) { rmsg.resize(strlen(m)+1); rmsg.sprintf("%s",m); tofree+=1;  };
      void setrNick(char *m) {  rnick.resize(strlen(m)+1); rnick.sprintf("%s",m);  tofree+=2;  };
      void setFirstName(char *m) {  firstname.resize(strlen(m)+1); firstname.sprintf("%s",m);  tofree+=4;  };
      void setLastName(char *m) {  lastname.resize(strlen(m)+1); lastname.sprintf("%s",m);  tofree+=8;  };
      void setEmail(char *m) {  email.resize(strlen(m)+1); email.sprintf("%s",m);   tofree+=16;  };
      void setrUrl(char *m) {  rurl.resize(strlen(m)+1); rurl.sprintf("%s",m);   tofree+=32;  };
      void setType(int t) {  type=t;  };

      const char *getrMsg() const {  return rmsg;  };
      const char *getrNick() const {  return rnick;  };
      const char *getFirstName() const {  return firstname;  };
      const char *getLastName() const {  return lastname;  };
      const char *getEmail() const {  return email;  };
      const char *getrUrl() const {  return rurl;  };

      int getType() const {  return type;  };
      int getRead() const {  return read;  };
      UIN getUin() const {  return uin;  };

      MESSAGE getMsg() const {  return msg;  };
      URL getUrl() const {  return url;  };
      ADDED getAdded() const {  return add;  };
      SEARCH_RESULT getSearch() const {  return sr;  };
   private:
      int tofree;
      int type;
      int read;
      UIN uin;
      MESSAGE msg;
      URL url;
      ADDED add;
      SEARCH_RESULT sr;
      QString rmsg;
      QString rnick;
      QString firstname;
      QString lastname;
      QString email;
      QString rurl;
};



//#define OFFLINE 0xFFFFFFFF



enum TableType {  Month=1, Week, Day  };

class tab : public KTabListBox
{
      Q_OBJECT
   public:
      tab(int t,QWidget *parent=0, const char *name=0, int col=1);
      ~tab();

   private:
      int status;
      int pos;
      QPopupMenu *menu;


      void doMousePressEvent(QMouseEvent *m);
      bool eventFilter(QObject *o, QEvent *e);
      QWidget *par;

      private slots:
	 void mouseDoubleClick(int,int);
   private:
      void showMsg();
      private slots:
	 void showInfo();
      void sendMSG();
      void sendURL();
   signals:
      void setUnRead(UIN uin);

};

class Users : public QWidget
{
      Q_OBJECT
   public:
      Users(QWidget *parent=0, const char* name=0);
      ~Users();

      void insertItem(UIN status,QString,UIN,int,int);
      int addItem(UIN);
      void changeItem(UIN,QString,UIN);
      void unSelectAll(int);
   private:

      void resizeEvent(QResizeEvent *);
      void updateView();
      void mousePressEvent(QMouseEvent *);
      bool eventFilter(QObject *, QEvent *event);
      void doMouseEvent(QMouseEvent *);



      public slots:
      void doSetUnRead(UIN);
      void highlight1(int , int );
      void highlight2(int , int );
   private:
      tab *avail, *offl;


};

#endif
