/**************************************************************************
* libXicq - Originally written by tnc (xtrophy@it.dk)                     *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* packets.h                                                               *
* Create packets                                                          *
**************************************************************************/


#ifndef _PACKETS_H
#define _PACKETS_H

#ifdef __FreeBSD__
#include <sys/types.h>
#endif
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "config.h"
#include "structs.h"
#include "contact.h"
#include "misc.h"
#include "v2_codes.h"


void packets_header(ICQ_PACKET &packet);
ICQ_PACKET packets_ack(int sequence);
ICQ_PACKET packets_msgAck(int sequence);
ICQ_PACKET packets_keepAlive();
ICQ_PACKET packets_login();
ICQ_PACKET packets_login_1();
ICQ_PACKET packets_contactList();
ICQ_PACKET packets_messageS(unsigned long int receiver, char *message); // Msg to go through the server
ICQ_PACKET packets_urlS(unsigned long int receiver, char *url, char *desc);
ICQ_PACKET packets_statusChange(unsigned long int status);
ICQ_PACKET packets_uinSearch(unsigned long int uin);
ICQ_PACKET packets_sendTextCode(char *textCode, unsigned short int X1);


#endif
