/**************************************************************************
* libXicq - Originally written by tnc (xtrophy@it.dk)                     *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* ui2lib.cpp                                                              *
* Functions the UI will call to send packages                             *
**************************************************************************/


#include "ui2lib.h"

extern USER_CONFIGURATION user_config;

void send_login()
{
    if (DEBUG)
        misc_log("Sending login packet.");
        
    ICQ_PACKET packet;
    packet = packets_login();
    net_udpSend(packet.data, packet.length);
}

void send_login_1()
{
    if (DEBUG)
        misc_log("Sending login_1 packet.");

    ICQ_PACKET packet;
    packet = packets_login_1();
    net_udpSend(packet.data, packet.length);
}

void send_ack(int sequence)
{
    if (DEBUG)
        misc_log("Sending ack.");

    ICQ_PACKET packet;
    packet = packets_ack(sequence);
    net_udpSend(packet.data, packet.length);
}

void send_msgAck(int sequence)
{
    if (DEBUG)
        misc_log("Sending msgAck.");

    ICQ_PACKET packet;
    packet = packets_msgAck(sequence);
    net_udpSend(packet.data, packet.length);
}

void send_keepAlive()
{
    if (DEBUG)
        misc_log("Sending keep alive.");

    ICQ_PACKET packet;
    packet = packets_keepAlive();
    net_udpSend(packet.data, packet.length);
}

void send_contactList()
{
    if (DEBUG)
        misc_log("Sending contact list.");

    ICQ_PACKET packet;
    packet = packets_contactList();
    net_udpSend(packet.data, packet.length);
}

void send_message(unsigned long int receiver, char *message)
{
    if (DEBUG)
        misc_log("Sending message.");

    ICQ_PACKET packet;
    packet = packets_messageS(receiver, message);
    net_udpSend(packet.data, packet.length);
}

void send_url(unsigned long int receiver, char *url, char *desc)
{
    if (DEBUG)
        misc_log("Sending url.");

    ICQ_PACKET packet;
    packet = packets_urlS(receiver, url, desc);
    net_udpSend(packet.data, packet.length);
}


void send_statusChange(unsigned long int status)
{
    if (DEBUG)
        misc_log("Sending status change.");

    ICQ_PACKET packet;
    packet = packets_statusChange(status);
    net_udpSend(packet.data, packet.length);

    user_config.status = status;
}

long int status_str2num(char *str) {
    long int tmp;
    long int _status;

    tmp = strtol(str, NULL, 0);

    switch (tmp) {
        case 0:// Available
            _status = STATUS_ONLINE;
            break;
        case 1:// Away
            _status = STATUS_AWAY;
            break;
        case 2:// Do Not Desturb (DND)
            _status = STATUS_DND;
            break;
        case 3:// N/A
            _status = STATUS_NA;
            break;
        case 4:// Occupied
            _status = STATUS_OCCUPIED;
            break;
        case 5:// Free For Chat
            _status = STATUS_FFC;
            break;
        case 6:// Invisible
            _status = STATUS_INVISIBLE;
            break;
	default:// Something else?
	    _status = -1;
    }
    // Add some code here to handle the case of the user inputting a string.
    return _status;
}

void send_uinSearch(unsigned long int uin)
{
    if (DEBUG)
        misc_log("Sending UIN search.");

    ICQ_PACKET packet;
    packet = packets_uinSearch(uin);
    net_udpSend(packet.data, packet.length);
}

void send_logout()
{
    if (DEBUG)
        misc_log("Sending logout packet.");

    ICQ_PACKET packet;
    packet = packets_sendTextCode("B_USER_DISCONNECTED", 5);
    net_udpSend(packet.data, packet.length);
}

char *returnMyStatus()
{
    return (contact_status2str(user_config.status));
}

