/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* io.cc                                                                   *
* Functions for input/output                                              *
**************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "io.h"

COLORS color;

char *aux_prompt;

int logFile = -1;


void icq_log(char *from_user, char *str) {
    char logTo[128];
    strcpy(logTo, user_cfg.logfile);
    if(strlen(from_user) > 0) {
      strcat(logTo, ".");
      strcat(logTo, from_user);
    }
//    printf("[%s] %s\n", from_user, logTo);
    logFile = open(logTo, 
                       O_WRONLY|O_CREAT|O_APPEND, S_IRUSR|S_IWUSR|S_IRGRP);
    write(logFile, str, strlen(str));
    close(logFile);
} // icq_log

void close_log() {
    if (logFile != -1) {
	close(logFile);
    }
} // close_log

void make_prompt()
{
    if (aux_prompt) {
	MY_PRINTF(color.none, "%s", aux_prompt);
	fflush(stdout);
    } else {
	MY_PRINTF(color.none, "\n%s - %s> ", NAME, returnMyStatus());
	fflush(stdout);
    }
}

int cmd_clear(char *input)
{
    printf("[2J\n");
    MY_PRINTF(color.titleB, "\n%s %s\n", LONGNAME, VERSION);
    MY_PRINTF(color.titleD, "-------------------------------------------------------------------------------\n");
    return 0;
}

void mainLoop()
{
    /*
    struct timeval tv;
    fd_set fd1, fd2;

    FD_ZERO(&fd2);
    */
    FD_SET(0, &fd1);

    time_t login_time;
    time_t login_begin;
    login_time = login_begin = time(NULL);

    int done = 0;
    while (!done)
    {
        tv.tv_sec = MIN(0, tv.tv_sec);
        tv.tv_usec = MIN(250, tv.tv_usec);
        icq_main();

        if(logged_in == 0)
        {
            if (login_time < time(NULL))
            {
                login_time = time(NULL);
                MY_PRINTF(color.none, ".");
                fflush(stdout);
            }

            if (login_begin + 20 < time(NULL))
            {
                MY_PRINTF(color.none, " Could not login!\n");
		MY_PRINTF(color.none, "Logging in, try %d", ++loginTry);
		login_time = login_begin = time(NULL);
                
                send_logout();
                send_login();
                //done = 1;
            }
        }

        //tv.tv_sec = 0;
        //tv.tv_usec = 250;
        //fd1 = fd2;
        //select(1, &fd1, NULL, NULL, &tv);
        if(FD_ISSET(0, &fd1))
        {
            char input[BUFSIZE];
            cin.getline(input, BUFSIZE);

            if (logged_in)
		done = !cmd_parse(input);
        }

        if (logged_in == -1)// We got kicked, relogin
        {
            logged_in = 0;
            send_login();
            loginTry = 1;
            MY_PRINTF(color.none, "Logging in, try %d", loginTry);
            login_time = login_begin = time(NULL);
        }
    }

}
