/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* io.h                                                                    *
* Functions for input/output                                              *
**************************************************************************/

#ifndef _IO_H
#define _IO_H

#include "main.h"
#include <stdio.h>

#define MY_PRINTF(color_, fmt, args...) do { \
		printf("%s", color_); \
		printf(fmt, ## args); \
		printf("%s", color.none); \
	    } while (0) 

#define MY_LOGF(color_, from_user, fmt, args...) do { \
		char *tmp_str; \
		asprintf(&tmp_str, fmt, ## args); \
		icq_log(from_user, tmp_str); \
		free(tmp_str); \
	    } while (0) 


#define MY_LAPRINTF(color_, from_user, fmt, args...) do { \
		char *tmp_str; \
		asprintf(&tmp_str, fmt, ## args); \
		printf("%s", color_); \
		printf("%s", tmp_str); \
		icq_log(from_user, tmp_str); \
		printf("%s", color.none); \
		free(tmp_str); \
	    } while (0) 


extern COLORS color;

extern char *aux_prompt;
extern void mainLoop();
extern void make_prompt();
extern int cmd_clear(char *input);
extern void icq_log(char *from_user, char *str);
extern void close_log();
#define makePrompt make_prompt

#endif // _IO_H
