/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* main.cc                                                                 *
* Handles communication with libXicq                                      *
**************************************************************************/


#include <stdio.h>
#include "main.h"
#include "io.h"


CALLBACK_FUNCTIONS callback_functions;

int logged_in = 0;
int loginTry = 1;


/*
**
** Main function
*/
int main()
{
    userConfigure(&user_cfg);
    
    callbackSetup(callback_functions);
    setupCallbacks(callback_functions);

    if (icq_init(&user_cfg) == -1)
    {
        MY_PRINTF(color.none, "Error - Couldn't initialize library\n");
        my_exit(1);
    }

    MY_PRINTF(color.titleB, "\n%s %s\n", LONGNAME, VERSION);
    MY_PRINTF(color.titleD, "-------------------------------------------------------------------------------\n");
    MY_PRINTF(color.none, "Logging in, try %d", loginTry);
    fflush(stdout);
    
    send_login();

    mainLoop();

    my_exit(0);
}


void my_exit(int val)
{
    send_logout();
    close_log();
    MY_PRINTF(color.titleD, "\n-------------------------------------------------------------------------------\n");
    exit (val);
}







